/* sorgente: CopiaVettInt.c */

/* Definizione e testing di una funzione che 
** copia il contenuto di un primo vettore in un secondo
** vettore di interi utilizzando le funzioni per la gestione
** della memoria
*/

/* inclusione dell'header file della libreria standard di
** definizioni di macro, costanti e dichiarazioni di funzioni e tipi
** per le varie operazioni di input/output */
#include <stdio.h>

/* inclusione dei file di intestazione delle librerie standard di
** definizioni di macro, costanti e dichiarazioni di funzioni e tipi
** di interesse generale, e per la gestione della memoria e delle stringhe */
#include <stdlib.h>
#include <string.h>

/* definizione della costante simbolica per la 
** dimensione del vettore */
#define DIM_VETT 5

/*
** funzione per l'acquisizione del contenuto di
** un vettore di interi
*/
void AcqVettInt(int *vett, int dim)
  {
  /* definizione del cursore per la scansione del
  ** vettore */
  int pos;
  
  /* scansione del vettore e acquisizione del suo
  ** contenuto */
  for (pos = 0; pos < dim; pos++)
    {
    printf("\nVett[%d]? ", pos);
    scanf("%d", &vett[pos]);
    };
  }

/*
** funzione per la visualizzazione del contenuto di
** un vettore di interi
*/
void ResVettInt(int *vett, int dim)
  {
  /* definizione del cursore per la scansione del
  ** vettore */
  int pos;
  
  /* scansione del vettore e restituzione del suo
  ** contenuto */
  for (pos = 0; pos < dim; pos++)
    printf("\nVett[%d]: %d", pos, vett[pos]);
  }

/*
** funzione che copia il contenuto di un primo vettore in un secondo
** vettore di interi utilizzando le funzioni per la gestione
** della memoria
*/ 
void CopiaVett(int *sorg, int *dest, int dim)
  {
  /* copia il vettore sorgente sul vettore destinazione */
  dest = (int *) memcpy(dest, sorg, dim*sizeof(int)); 
  }
  
/* Test */

int main()
  {
  /* definizione del vettore sorgente */
  int sorgente[DIM_VETT];
  
  /* definizione del vettore destinazione */
  int destinazione[DIM_VETT];
  
  /* acquisizione del vettore sorgente */
  printf("\nAcquisizione vettore sorgente\n");
  AcqVettInt(sorgente, DIM_VETT);
  
  /* copia il vettore sorgente su quello di destinazione */
  CopiaVett(sorgente, destinazione, DIM_VETT);
  
  /* visualizza il contenuto del vettore sorgente
  ** e di quello destinazione */
  printf("\n\nVettore Sorgente:\n");
  ResVettInt(sorgente, DIM_VETT);
  printf("\n\nVettore Destinazione:\n");
  ResVettInt(destinazione, DIM_VETT);
  
  return(1);
  }
